unit MarqueeBar;

interface

uses Windows, SysUtils, Classes, Controls, ComCtrls, Messages;

const
  PBS_MARQUEE  = $08;
  PBM_SETMARQUEE = WM_USER + 10;

type
  TProgressBar = class (ComCtrls.TProgressBar)
   private
    FActive: Boolean;
    FSpeed: Cardinal;
    procedure SetActive(const Value: Boolean);
    procedure SetSpeed(const Value: Cardinal);
    procedure UpdateProgressBar;
   protected
    procedure CreateParams(var Params: TCreateParams); override;
   public
    constructor Create(AOwner: TComponent); override;
   published
    property Active: Boolean read FActive write SetActive;
    property Speed: Cardinal read FSpeed  write SetSpeed;
  end;

implementation

constructor TProgressBar.Create(AOwner: TComponent);
begin
 inherited;
 FSpeed := 60;
end;

procedure TProgressBar.CreateParams(var Params: TCreateParams);
begin
 inherited;
 Params.Style := Params.Style or PBS_MARQUEE;
end;

procedure TProgressBar.SetActive(const Value: Boolean);
begin
  FActive := Value;
  UpdateProgressBar;
end;

procedure TProgressBar.SetSpeed(const Value: Cardinal);
begin
  FSpeed := Value;
  UpdateProgressBar;
end;

procedure TProgressBar.UpdateProgressBar;
begin
 case FActive of
  False: SendMessage(Handle, PBM_SETMARQUEE, 0, 0);
  True: SendMessage(Handle, PBM_SETMARQUEE, 1, FSpeed)
 end;
end;

end.
