unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, LEA, Counters, StdCtrls, ComCtrls;

type
  TMainForm = class(TForm)
    AddBtn: TButton;
    ClearBtn: TButton;
    QuitBtn: TButton;
    InfoLbl: TLabel;
    OpenDlg: TOpenDialog;
    FileList: TListView;
    procedure FormCreate(Sender: TObject);
    procedure QuitBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure AddBtnClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  MainForm: TMainForm;
  Counter: TCounter;

implementation

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin
 Counter := TCounter.Create(MILLISECONDS);
 DoubleBuffered := True;
 FileList.DoubleBuffered := True;
 FileList.Column[0].Width := 275;
 FileList.Column[1].Width := 130;
 FileList.Column[2].Width := 70;
 FileList.Column[3].Width := 90;
end;

procedure TMainForm.QuitBtnClick(Sender: TObject);
begin
 Close;
end;

procedure TMainForm.ClearBtnClick(Sender: TObject);
begin
 FileList.Clear;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Counter.Free;
end;

procedure TMainForm.AddBtnClick(Sender: TObject);
const
 MB = 1024 * 1024;
Var
 I: Integer;
 FH, S: Longword;
 H, N, Sz: String;
 T: Single;
 TS: String;
begin
 S := 0;

 if OpenDlg.Execute then
  for I := 0 to OpenDlg.Files.Count - 1 do
  begin
   FH := CreateFile(PChar(OpenDlg.Files.Strings[I]), GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_WRITE,
                    nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL or FILE_FLAG_SEQUENTIAL_SCAN, 0);

   if FH = INVALID_HANDLE_VALUE then Exit else
    begin
     S := GetFileSize(FH, nil);
     CloseHandle(FH);
    end;

   Sz := Format('%d o', [S]);
   if S > 1024 then Sz := Format('%d Ko', [S div 1024]);
   if S > MB then   Sz := Format('%d Mo', [S div MB]);

   Counter.Reset;
   H := String(HashToString(HashFile(AnsiString(OpenDlg.Files.Strings[I]))));
   T := Counter.Value;

   TS := Format('%.2f ms', [T]);
   if T > 1000 then TS := Format('%.2f s', [T / 1000]);

   N := ExtractFileName(OpenDlg.Files.Strings[I]);
   with FileList.Items.Add do
    begin
     Caption := H;
     SubItems.Add(N);
     SubItems.Add(Sz);
     SubItems.Add(TS);
    end;
  end;

 FileList.SortType := stText;
end;

end.
